SystemOrganization addCategory: #'Practica2Test-Ejercicio1'!
SystemOrganization addCategory: #'Practica2Test-Ejercicio2'!
SystemOrganization addCategory: #Practica2Test!

Object subclass: #FabricaEmpleados
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2Test-Ejercicio1'!

!FabricaEmpleados methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/18/2012 02:31'!
EC1
	| ec1 |
	ec1 := EmpleadoContratado
		conNombre: 'Cintia Castaa'
		conDireccion: 'San Martn 2100'
		conEstadoCivil: 'Casada'
		conFechaNacimiento: (Date year: 1987 month: 12 day: 18)
		conSueldoBasico: 7500
		conNumeroContrato: 6784
		conMedioPago: 'Cheque'.
	^ ec1! !

!FabricaEmpleados methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/18/2012 01:54'!
EP1
	| ep1 |
	ep1 := EmpleadoPermanente
		conNombre: 'Betiana Rocha'
		conDireccion: 'Alcorta 1500'
		conEstadoCivil: 'Casada'
		conFechaNacimiento: (Date year: 1979 month: 10 day: 23)
		conSueldoBasico: 8000
		conCantidadHijos: 2
		conAntiguedad: 5.
	^ ep1! !

!FabricaEmpleados methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/18/2012 02:38'!
EP2
	| ep2 |
	ep2 := EmpleadoPermanente
		conNombre: 'Cristian Cemero'
		conDireccion: 'Sabatini 640'
		conEstadoCivil: 'Soltero'
		conFechaNacimiento: (Date year: 1982 month: 9 day: 14)
		conSueldoBasico: 6000
		conCantidadHijos: 0
		conAntiguedad: 3.
	^ ep2! !

!FabricaEmpleados methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/18/2012 01:54'!
ET1
	| et1 |
	et1 := EmpleadoTemporario
		conNombre: 'Laura Pozzi'
		conDireccion: 'Sucre 250'
		conEstadoCivil: 'Soltera'
		conFechaNacimiento: (Date year: 1980 month: 5 day: 14)
		conSueldoBasico: 4000
		conFinContrato: (Date year: 2014 month: 1 day: 1)
		conCantidadHorasExtra: 12.
	^ et1! !

!FabricaEmpleados methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/18/2012 02:39'!
ET2
	| et2 |
	et2 := EmpleadoTemporario
		conNombre: 'Juan Jos Lopez'
		conDireccion: 'Sarmiento 2450'
		conEstadoCivil: 'Casado'
		conFechaNacimiento: (Date year: 1950 month: 12 day: 20)
		conSueldoBasico: 9000
		conFinContrato: (Date year: 2014 month: 1 day: 1)
		conCantidadHorasExtra: 0.
	^ et2! !

TestCase subclass: #EmpleadoContratadoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2Test-Ejercicio2'!

!EmpleadoContratadoTest methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/14/2012 21:21'!
testSueldoNetoContratado
	"Se crea un empleado contratado (EC1), se le pide que calcule su sueldo neto 
	y se chequea que el valor devuelto sea el esperado. (7450)"

	| fabrica sueldoNeto |
	fabrica := FabricaEmpleados new.
	sueldoNeto := fabrica EC1 calcularSueldoNeto.
	self assert: sueldoNeto = 7450! !

TestCase subclass: #EmpleadoPermanenteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2Test-Ejercicio1'!

!EmpleadoPermanenteTest methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 21:14'!
testSueldoNetoPermanente
	"Se crea un empleado de planta permanente (EP1), se le pide que calcule su sueldo neto 
	y se chequea que el valor devuelto sea el esperado. (6447.5)"

	| fabrica sueldoNeto |
	fabrica := FabricaEmpleados new.
	sueldoNeto := fabrica EP1 calcularSueldoNeto.
	self assert: sueldoNeto = 6447.5! !

TestCase subclass: #EmpleadoTemporarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2Test-Ejercicio1'!

!EmpleadoTemporarioTest methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 21:13'!
testSueldoNetoEmpleadoPermanente
	"Se crea un empleado de planta temporaria (ET1), se le pide que calcule su sueldo neto 
	y se chequea que el valor devuelto sea el esperado. (3524)"

	| fabrica sueldoNeto |
	fabrica := FabricaEmpleados new.
	sueldoNeto := fabrica ET1 calcularSueldoNeto.
	self assert: sueldoNeto = 3524! !

TestCase subclass: #EmpresaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2Test-Ejercicio1'!

!EmpresaTest methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 21:03'!
testLiquidarSueldos
	"se crean dos empleados de planta permanente (EP1, EP2), dos empleados de planta temporaria (ET1, ET2) y se los agrega a la empresa; se pide a la empresa que realice la liquidacin de sueldos; se le pide a la empresa los Recibos de Sueldos generados y se chequea que la sumatoria de los sueldosNetos de los Recibos de Sueldos sea la esperada"

	| fabrica empresa totalSueldosNetosRecibos |
	fabrica := FabricaEmpleados new.
	empresa := Empresa new.
	empresa
		addEmpleado: fabrica EP1;
		addEmpleado: fabrica EP2;
		addEmpleado: fabrica ET1;
		addEmpleado: fabrica ET2.
	totalSueldosNetosRecibos := 0.
	empresa realizarLiquidacionSueldos.
	Transcript clear.
	empresa recibos
		do: [ :recibo | 
			totalSueldosNetosRecibos := totalSueldosNetosRecibos + recibo sueldoNeto.
			Transcript show: recibo ].
	self assert: totalSueldosNetosRecibos = 21759! !

!EmpresaTest methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 21:07'!
testTotalRetenciones
	"se crean dos empleados de planta permanente (EP1, EP2), dos empleados de planta temporaria 
	(ET1, ET2) y se los agrega a la empresa; se pide a la empresa que calcule el total de 
	retenciones y se chequea que el valor devuelto sea el	 esperado"

	| fabrica empresa totalRetenciones |
	fabrica := FabricaEmpleados new.
	empresa := Empresa new.
	empresa
		addEmpleado: fabrica EP1;
		addEmpleado: fabrica EP2;
		addEmpleado: fabrica ET1;
		addEmpleado: fabrica ET2.
	totalRetenciones := empresa calcularTotalRetenciones.
	self assert: totalRetenciones = 6521! !

!EmpresaTest methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 21:07'!
testTotalSueldosBrutos
	"se crean dos empleados de planta permanente (EP1, EP2), dos empleados de planta temporaria 
	(ET1, ET2) y se los agrega a la empresa; se pide a la empresa que calcule el total de 
	sueldos brutos y se chequea que el valor devuelto sea el	esperado"

	| fabrica empresa totalSueldosBrutos |
	fabrica := FabricaEmpleados new.
	empresa := Empresa new.
	empresa
		addEmpleado: fabrica EP1;
		addEmpleado: fabrica EP2;
		addEmpleado: fabrica ET1;
		addEmpleado: fabrica ET2.
	totalSueldosBrutos := empresa calcularTotalSueldosBrutos.
	self assert: totalSueldosBrutos = 28280! !

!EmpresaTest methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 21:08'!
testTotalSueldosNetos
	"se crean dos empleados de planta permanente (EP1, EP2), dos empleados de planta temporaria 
	(ET1, ET2) y se los agrega a la empresa; se pide a la empresa que calcule el total de 
	sueldos netos y se chequea que el valor devuelto sea el esperado"

	| fabrica empresa totalSueldosNetos |
	fabrica := FabricaEmpleados new.
	empresa := Empresa new.
	empresa
		addEmpleado: fabrica EP1;
		addEmpleado: fabrica EP2;
		addEmpleado: fabrica ET1;
		addEmpleado: fabrica ET2.
	totalSueldosNetos := empresa calcularTotalSueldosNetos.
	self assert: totalSueldosNetos = 21759! !

TestCase subclass: #EmpresaTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2Test-Ejercicio2'!

!EmpresaTest2 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 21:09'!
testLiquidarSueldos
	"se crean dos empleados de planta permanente (EP1, EP2), dos empleados de planta temporaria (ET1, ET2), un empleado contratado (EC1) y se los agrega a la empresa; se pide a la empresa que realice la liquidacin de sueldos; se le pide a la empresa los Recibos de Sueldos generados y se chequea que la sumatoria de los sueldosNetos de los Recibos de Sueldos sea la esperada"

	| fabrica empresa totalSueldosNetosRecibos |
	fabrica := FabricaEmpleados new.
	empresa := Empresa new.
	empresa
		addEmpleado: fabrica EP1;
		addEmpleado: fabrica EP2;
		addEmpleado: fabrica ET1;
		addEmpleado: fabrica ET2;
		addEmpleado: fabrica EC1.
	totalSueldosNetosRecibos := 0.
	empresa realizarLiquidacionSueldos.
	Transcript clear.
	empresa recibos
		do: [ :recibo | 
			totalSueldosNetosRecibos := totalSueldosNetosRecibos + recibo sueldoNeto.
			Transcript show: recibo ].
	self assert: totalSueldosNetosRecibos = 29209! !

!EmpresaTest2 methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/14/2012 21:23'!
testTotalRetenciones
	"se crean dos empleados de planta permanente (EP1, EP2), dos empleados de planta temporaria 
	(ET1, ET2), un empleado contratado (EC1) y se los agrega a la empresa; se pide a la empresa 
	que calcule el total de retenciones y se chequea que el valor devuelto sea el esperado"

	| fabrica empresa totalRetenciones |
	fabrica := FabricaEmpleados new.
	empresa := Empresa new.
	empresa
		addEmpleado: fabrica EP1;
		addEmpleado: fabrica EP2;
		addEmpleado: fabrica ET1;
		addEmpleado: fabrica ET2;
		addEmpleado: fabrica EC1.
	totalRetenciones := empresa calcularTotalRetenciones.
	self assert: totalRetenciones = 6571! !

!EmpresaTest2 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 20:59'!
testTotalSueldosBrutos
	"se crean dos empleados de planta permanente (EP1, EP2), dos empleados de planta temporaria 
	(ET1, ET2), un empleado contratado (EC1) y se los agrega a la empresa; se pide a la empresa 
	que calcule el total de sueldos brutos y se chequea que el valor devuelto sea el esperado"

	| fabrica empresa totalSueldosBrutos |
	fabrica := FabricaEmpleados new.
	empresa := Empresa new.
	empresa
		addEmpleado: fabrica EP1;
		addEmpleado: fabrica EP2;
		addEmpleado: fabrica ET1;
		addEmpleado: fabrica ET2;
		addEmpleado: fabrica EC1.
	totalSueldosBrutos := empresa calcularTotalSueldosBrutos.
	self assert: totalSueldosBrutos = 35780! !

!EmpresaTest2 methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 20:56'!
testTotalSueldosNetos
	"se crean dos empleados de planta permanente (EP1, EP2), dos empleados de planta temporaria 
	(ET1, ET2), un empleado contratado (EC1) y se los agrega a la empresa; se pide a la empresa 
	que calcule el total de sueldos netos y se chequea que el valor devuelto sea el esperado"

	| fabrica empresa totalSueldosNetos |
	fabrica := FabricaEmpleados new.
	empresa := Empresa new.
	empresa
		addEmpleado: fabrica EP1;
		addEmpleado: fabrica EP2;
		addEmpleado: fabrica ET1;
		addEmpleado: fabrica ET2;
		addEmpleado: fabrica EC1.
	totalSueldosNetos := empresa calcularTotalSueldosNetos.
	self assert: totalSueldosNetos = 29209! !
